#!/usr/bin/perl -w
#
# Copyright (C) 2001,2002 asdfGroup.com Inc. All rights reserved.
#
# This library is a commercial product and it is subject to the license
# agreement that can be found at the following URL:
#   http://www.asdfGroup.com/license.html
# Please contact our staff if you will have any questions:
#   mailto:staff@asdfGroup.com
#
        
package POWER::lib;
use strict; 

use POSIX; # for sigaction() in time.pl
use constant MIN_INT  => 0.01;
use constant SIG_CRON => 50;

our $VERSION = "2.15";
our $AUTOLOAD;
our $TIME = undef;

sub import {
    POWER::lib::time() if grep {$_ eq "time"} @_;
    POWER::lib::_CronInit() if grep {$_ eq '$TIME'} @_;
    my $pkg = caller()."::";
    no strict 'refs';
    *{$pkg.$_} = \&$_ for qw(EncUri UnEncUri Enc UnEnc Diff vars Dumper4Eval
	Eval RandCh abs_url Check_Email Email MD5 MD5hex MD5base64 EncBase64
	UpdateHash Min Max CalcNavigation Cat Echo MEM_used FD_used Chomp
	ConkOut CronSet CronDel Limit_CPU CPU_used
	HexDump2Bin Bin2HexDump Bin2HexDiff), grep {m/^\w/} @_;
    *{$pkg.$_} = \$$_ for map {local $_=$_;s/^\$//;$_} grep {m/^\$/} @_;
}

sub time ();
sub Eval ($);

my %subs = (
    map({$_=>"email.pl"}    qw(Check_Email Email)),
    map({$_=>"encoding.pl"} qw(EncUri UnEncUri Enc UnEnc)),
    map({$_=>"macro.pl"}    qw(Chomp Cat Echo Min Max Dumper4Eval Eval)),
    map({$_=>"md5.pl"}      qw(MD5 MD5hex MD5base64 EncBase64)),
    map({$_=>"debug.pl"}    qw(HexDump2Bin Bin2HexDump Bin2HexDiff)),
    map({$_=>"misc.pl"}     qw(RandCh abs_url UpdateHash Diff CalcNavigation)),
    map({$_=>"resource.pl"} qw(MEM_used FD_used CPU_used Limit_CPU)),
    map({$_=>"time.pl"}     qw(time sleep ConkOut CronSet CronDel _CronInit
			       _CronExecute)),
    );
(my $this = __PACKAGE__)        =~ s!::!/!g;
(my $path = $INC{$this.".pm"})  =~ s{pm$}{subs/};
# FIXME  $path ,     
%subs = map { __PACKAGE__."::$_" => $path.$subs{$_} } keys %subs;
sub AUTOLOAD {
    do $subs{$AUTOLOAD} or die "$@ (AUTOLOAD=$AUTOLOAD)";
    goto &$AUTOLOAD;
}

1;

