#!/usr/bin/perl -w
# TODO check about "\r"
use Test; 
BEGIN { plan tests => 13 }
BEGIN { unshift @INC, "../blib/lib" }
use POWER::lib;

# interface check

@none   = Chomp();
ok(@none, 0,            "no params, as list");

$none   = Chomp();
ok($none, undef,        "no params, as scalar");

($none) = Chomp('');
ok($none, '',           "empty string, as list");

$none   = Chomp('');
ok($none, '',           "empty string, as scalar");

$in     = "one line without CR";
($out)  = Chomp($in);
ok($in, $out,           "one line without CR, as list");

$out    = Chomp($in);
ok($in, $out,           "one line without CR, as scalar");

for (1..3) {
    @in     = (1 .. $_);
    @out    = Chomp(@in);
    ok(@in, @out,           "list of $_ element(s)");
}

# logic check

$in     = "one line with CR\n";
$out    = Chomp($in);
$expect = "one line with CR";
ok($out, $expect,           "one line with CR");

$in     = "one line with 2 CR\n\n";
$out    = Chomp($in);
$expect = "one line with 2 CR\n";
ok($out, $expect,           "one line with 2 CR");

$in     = "two lines\nwith CR\n";
$out    = Chomp($in);
$expect = "two lines\nwith CR";
ok($out, $expect,           "two lines with CR");

@in     = ("line1\n", "line2", "line3\n");
$out    = join "", Chomp(@in);
$expect = join "", ("line1", "line2", "line3");
ok($out, $expect,           "array of lines with and without CR");

